
int tempGraph[] = {50, 50, 50, 150};
int tempSettings[] = {0, 150, 80, 110};

int vocGraph[] = {120, 50, 50, 150};
int vocSettings[] = {0, 200, 140, 160};

int humGraph[] = {190, 50, 50, 150};
int humSettings[] = {0, 100, 70, 90};

int pressGraph[] = {230, 50, 50, 150};
int pressSettings[] = {0, 3000, 3000, 3000};

char *envMenuArr[] = {"WEATHER", "ENV SENS", "OUTER", "INNER"};
int envArrayNum = 4;


void displayEnviro() {
  envInt++;

  if (envInt > 2) {
    envInt = 1;
  }
  allButtonsOff();
  if (envInt == 1) {
    envMenuArr[0] = "WEATHER";
    lcarsBackground(st_PURPLE, envMenuArr, envArrayNum, 3);
    displayWeather();

  } else if (envInt == 2) {
    envMenuArr[0] = "INDOOR READINGS";
    lcarsBackground(st_PURPLE, envMenuArr, envArrayNum, 4);
    displayEnvReadings();
  }
}

void buttonClick() {

}


void displayEnvReadings() {

  allButtonsOff();
  drawBarGraph(tempGraph[0], tempGraph[1], tempGraph[2], tempGraph[3], tempSettings[0], tempSettings[1], tempSettings[2], tempSettings[3], indoorTemp, "TEMP", "*C", st_LTGRAY);
  drawBarGraph(vocGraph[0], vocGraph[1], vocGraph[2], vocGraph[3], vocSettings[0], vocSettings[1], vocSettings[2], vocSettings[3], indoorVOC, "VOC", "kOhms", st_LTGRAY);
  drawBarGraph(humGraph[0], humGraph[1], humGraph[2], humGraph[3], humSettings[0], humSettings[1], humSettings[2], humSettings[3], indoorHum, "HUM", "%", st_LTGRAY);
 // drawBarGraph(pressGraph[0], pressGraph[1], pressGraph[2], pressGraph[3], pressSettings[0], pressSettings[1], pressSettings[2], pressSettings[3], indoorPres, "PRES", "hPA", st_LTGRAY);
}


void drawBarGraph(int x, int y, int w, int h, int minVal, int maxVal, int ya, int ra, float reading, char *label, char *measure, uint16_t borderColor) {

  int tagH = 30;
  tft.fillRect(x, y, w, tagH, borderColor);

  tft.loadFont(STFONT18);
  tft.setTextColor(st_BLACK, borderColor);
  tft.setTextDatum(BR_DATUM);
  tft.drawString(label, x + w - 2, y + tagH, 8);

  y += tagH + 10;
  int margin = 2;

  tft.fillRect(x, y, w, h, borderColor);

  y += margin;
  h -= margin * 2;

  //int yaY = map(ya,0,maxVal,y+h,y);
  //tft.fillRect(x, yaY, w, 6, st_YELLOW);

  x += margin + 2 ;
  y += margin + 2;
  w -= (margin * 2 + 4);
  h -= (margin * 2 + 4);
  tft.fillRect(x, y, w, h, st_BLACK);

  x += +1 ;
  y += +1;
  w -= 2;
  h -= 2 ;

  int readingY = map(reading, minVal, maxVal, y + h, y);

  uint16_t fillColor = st_BLUE;

  if (reading > ra) {
    fillColor = st_RED;
  }

  if (reading > ya) {
    fillColor = st_YELLOW;
  }

  int readingH = (y + h) - readingY;
  tft.fillRect(x, readingY, w, readingH , fillColor);

  tft.loadFont(STFONT24);
  int padding = tft.textWidth("999"); // get the width of the text in pixels
  tft.setTextPadding(padding);
  tft.setTextColor(st_WHITE, st_BLACK);
  tft.setTextDatum(MC_DATUM);
  tft.drawNumber(reading, x + w / 2, readingY + readingH + 20, 8);
  tft.drawString(measure, x + w / 2, readingY + readingH + 45, 8);

}
