
char *fitMenuArr[] = {"HEALTH", "FITNESS", "AVERAGE", "TODAY", "YESTERDAY"};
int fitArrayNum = 5;

void loadFitnessJSON() {

  if (!isAuth(1)) {
    requestDeviceCode("google");
    return;
  }

  allButtonsOff();

  File fitnessJSON = SPIFFS.open("/fitness.json", FILE_READ);

  if (!fitnessJSON) {
    Serial.println("The file does not exist");
    return;
  } else {
    if ( fitnessJSON.size() == 0 ) {
      Serial.println("The file is empty");
    } else {
      Serial.println("Getting data");

      const size_t capacity = JSON_ARRAY_SIZE(1) + 5 * JSON_ARRAY_SIZE(7) + JSON_OBJECT_SIZE(11) + 300;
      DynamicJsonDocument doc(capacity);

      DeserializationError err = deserializeJson(doc, fitnessJSON);

      if (err) {
        Serial.print(F("deserializeJson() failed: "));
        Serial.println(err.c_str());
        return;
      }

      //serializeJson(doc, Serial);

      char dateTitle[25];
      char heartTitle[25];
      char stepTitle[25];
      char moveTitle[25];
      int weight = 0;
      int steps;
      int moveMins;
      int heartPoints;
      int calories;
      int i = 0;

      JsonArray days = doc["days"];
      // JsonArray stepsA = doc["steps"];
      // JsonArray moveMins = doc["moveMins"];
      //  JsonArray heartPoints = doc["heartPoints"];


      const char* days_0 = days[0];
      const char* days_5 = days[5];
      const char* days_6 = days[6];
      //fitMenuArr[4] = (char*)days_5;

      if (fitnessItem > 2) {
        fitnessItem = 0;
      }

      if (fitnessItem == 0) {

        strcpy(dateTitle, days_0);
        strcat(dateTitle, " - " );
        strcat(dateTitle, days_6);

        strcpy(heartTitle, "TOTAL HEART MINS");
        strcpy(stepTitle, "AVERAGE STEPS");
        strcpy(moveTitle, "AVERAGE MOVE MINS");

        steps = doc["avgSteps"]; // 5982
        moveMins = doc["avgMoveMins"]; // 59
        heartPoints = doc["totalHeartPoints"]; // 234
        weight = doc["avgWeight"]; // 182

        // fitMenuArr[0] = "HEALTH: WEEKLY AVERAGE";
        lcarsBackground(st_NTBLUE, fitMenuArr, fitArrayNum, 3);


      } else {

        if (fitnessItem == 1) {

          strcpy(dateTitle, "TODAY: ");
          strcat(dateTitle, days_6);
          i = 6;

          //fitMenuArr[0] = "TODAY'S FITNESS";
          lcarsBackground(st_NTBLUE, fitMenuArr, fitArrayNum, 4);

        } else {

          strcpy(dateTitle, "YESTERDAY: ");
          strcat(dateTitle, days_5);
          i = 5;

          //fitMenuArr[0] = "YESTERDAY'S FITNESS";
          lcarsBackground(st_NTBLUE, fitMenuArr, fitArrayNum, 5);

        }


        steps = doc["steps"][i];
        moveMins = doc["moveMins"][i];
        heartPoints = doc["heartPoints"][i];
        calories = doc["calories"][i];

        strcpy(heartTitle, "HEART MINS");
        strcpy(stepTitle, "STEPS");
        strcpy(moveTitle, "MOVE MINS");

      }
      fitnessItem++;

      fex.drawBmp("/bodyScan.bmp", 10, 30);
      tft.setTextColor(st_WHITE, st_BLACK);
      tft.loadFont(STFONT28);

      int x = 95;
      int y = 30;
      tft.setCursor(x, y);
      tft.print(dateTitle);

      int lineLength = 140;
      int lineStartX = 130;
      int radius = 6;

      int xA;
      int yA;
      int yB;

      //WEIGHT------------------
      yB = 100;
      if (weight > 0) {

        tft.loadFont(STFONT24);
        tft.setTextDatum(BR_DATUM);

        tft.drawString("AVERAGE WEIGHT", lineStartX + lineLength, yB, 8);

        tft.loadFont(STFONT24);
        tft.setTextDatum(TR_DATUM);
        tft.drawNumber(weight, lineStartX + lineLength , yB + 2, 8);

      }

      if (fitnessItem > 1) {

        tft.loadFont(STFONT24);
        tft.setTextDatum(BR_DATUM);

        tft.drawString("CALORIES BURNED", lineStartX + lineLength, yB, 8);

        tft.loadFont(STFONT24);
        tft.setTextDatum(TR_DATUM);
        tft.drawNumber(calories, lineStartX + lineLength , yB + 2, 8);

      }


      //HEART MINUTES------------------

      xA = 80;
      yA = 110;
      yB = yA + 52;

      tft.drawCircle(xA, yA, radius, st_GREEN);
      tft.drawLine(xA, yA, lineStartX, yB, st_WHITE);
      tft.drawFastHLine(lineStartX, yB, lineLength, st_WHITE);

      tft.loadFont(STFONT24);
      tft.setTextDatum(BR_DATUM);

      tft.drawString(heartTitle, lineStartX + lineLength, yB, 8);

      tft.loadFont(STFONT24);
      tft.setTextDatum(TR_DATUM);
      tft.drawNumber(heartPoints, lineStartX + lineLength , yB + 4, 8);

      //STEPS ------------------
      xA = 80;
      yA = 290;
      yB = yA - 63;

      tft.drawCircle(xA, yA, radius, st_GREEN);
      tft.drawLine(xA, yA, lineStartX, yB, st_WHITE);
      tft.drawFastHLine(lineStartX, yB, lineLength, st_WHITE);

      tft.loadFont(STFONT24);
      tft.setTextDatum(BR_DATUM);

      tft.drawString(stepTitle, lineStartX + lineLength, yB, 8);

      tft.loadFont(STFONT24);
      tft.setTextDatum(TR_DATUM);
      tft.drawNumber(steps, lineStartX + lineLength , yB + 4, 8);

      //MOVE MINUTES ------------------

      xA = 20;
      yA = 310;
      yB = yA - 20;
      tft.drawFastHLine(xA, yA, 100, st_WHITE);
      tft.drawLine(xA + 100, yA, lineStartX, yB, st_WHITE);
      tft.drawFastHLine(lineStartX, yB, lineLength, st_WHITE);

      tft.loadFont(STFONT24);
      tft.setTextDatum(BR_DATUM);

      tft.drawString(moveTitle, lineStartX + lineLength, yB, 8);

      tft.loadFont(STFONT24);
      tft.setTextDatum(TR_DATUM);
      tft.drawNumber(moveMins, lineStartX + lineLength , yB + 4, 8);


    }
  }
}
