
char *mkrMenuArr[] = {"LED CALCULATOR", "MAKER", "LED CALC", "RES CHRT", "PWR SNSR"};
int mkrArrayNum = 5;
volatile int mkrInt = 0;

boolean ledCalcScreen = false, resCodeScreen = false, measurePwrScreen = false;

void displayMaker() {
  mkrInt++;
  powerReadingsDisplay = false;

  if (mkrInt > 3) {
    mkrInt = 1;
  }
  allButtonsOff();
  if (mkrInt == 1) {
    mkrMenuArr[0] = "LED CALCULATOR";
    lcarsBackground(st_ORANGE, mkrMenuArr, mkrArrayNum, 3);
    displayLEDCalc(st_ORANGE);
    ledCalcScreen = true;
  } else if (mkrInt == 2) {
    mkrMenuArr[0] = "RESISTOR CHART";
    lcarsBackground(st_ORANGE, mkrMenuArr, mkrArrayNum, 4);
    displayResChart(st_ORANGE);
    resCodeScreen = true;
    //mkrMenuArr[0] = "RESISTOR COLOR CODE";
    //lcarsBackground(st_ORANGE, mkrMenuArr, mkrArrayNum, 4);
    //displayResCode(st_ORANGE);
    //resCodeScreen = true;
  }
  else if (mkrInt == 3) {
    mkrMenuArr[0] = "POWER SENSOR";
    lcarsBackground(st_ORANGE, mkrMenuArr, mkrArrayNum, 5);
    measurePower(st_ORANGE);
    measurePwrScreen = true;
    powerReadingsDisplay  = true;
  }

}

float vs;
float vf;
int cf;
char resistance[10];

int vsX;
int vsY;
int vfX;
int vfY;
int cfX;
int cfY;
int rX;
int rY;

tsButton vsInc, vsDec, vfInc, vfDec, cfInc, cfDec;

int cfUP[] = {0, 0, 0, 0};

tsButton bl1, br1, re1, or1, ye1, gr1, bu1, vi1, gy1, wh1;

void displayResChart(uint16_t backgroundColor) {
  tft.loadFont(STFONT24);
  tft.setTextColor(st_WHITE, st_BLACK);

  int x = 30;
  int y = 30;
  int boxW = 45;
  int boxH = 25;
  int origX = x;
  int origY = y;

  char *headers[] = {"1st", "2nd", "3rd"};
  for (int i = 0; i < 3; i++) {

    tft.fillRect(x, y, boxW, boxH, st_DKGRAY);
    tft.drawRect(x, y, boxW, boxH, st_WHITE);
    tft.setTextColor(st_WHITE, st_DKGRAY);
    tft.setTextDatum(MC_DATUM);
    tft.drawString(headers[i], x + boxW / 2, y + boxH / 2, 8);
    x += boxW;
  }

  uint16_t black = 0x0000;
  uint16_t brown = 0x8200;
  uint16_t red = 0xF800;
  uint16_t orange = 0xFC00;
  uint16_t yellow = 0xFFE0;
  uint16_t green = 0x0408;
  uint16_t blue = 0x001F;
  uint16_t violet = 0x801F;
  uint16_t gray = 0x8410;
  uint16_t white = 0xFFFF;
  uint16_t gold = 0xFEA0;
  uint16_t silver = 0xC618;
  uint16_t colorArr[] = {black, brown, red, orange, yellow, green, blue, violet, gray, white};
  char *multiArr[] = {"1", "10", "100", "1K", "10K", "100K", "1M", "10M", "100M", "1G"};

  x = origX;
  y += boxH;

  for (int i = 0; i < 10; i++) {

    for (int j = 0; j < 3; j++) {

      tft.fillRect(x, y, boxW, boxH, colorArr[i]);
      tft.drawRect(x, y, boxW, boxH, st_WHITE);
      tft.setTextColor(st_BLACK, colorArr[i]);

      if (i < 2) {
        tft.setTextColor(st_WHITE, colorArr[i]);
      }
      tft.setTextDatum(MC_DATUM);

      if (j < 2) {
        tft.drawNumber(i, x + boxW / 2, y + boxH / 2, 8);
      } else {
        tft.drawString(multiArr[i], x + boxW / 2, y + boxH / 2, 8);
      }
      x += boxW;

    }
    x = origX;
    y += boxH;
  }

  //Tolerances

  uint16_t tolColorArr[] = {gold, silver};
  char *tolValArr[] = {"GOLD - 5%", "SILVER - 10%"};


  origX += (boxW * 3.3);
  boxW = 90;
  x = origX;
  y = origY;

  //Tolerance Header
  tft.fillRect(x, y, boxW, boxH, st_DKGRAY);
  tft.drawRect(x, y, boxW, boxH, st_WHITE);
  tft.setTextColor(st_WHITE, st_DKGRAY);
  tft.setTextDatum(MC_DATUM);

  tft.drawString("4th - TOL", x + boxW / 2, y + boxH / 2, 8);


  for (int i = 0; i < 2; i++) {
    x = origX;
    y += boxH;
    tft.fillRect(x, y, boxW, boxH, tolColorArr[i]);
    tft.drawRect(x, y, boxW, boxH, st_WHITE);
    tft.setTextColor(st_BLACK, tolColorArr[i]);
    tft.setTextDatum(MC_DATUM);

    tft.drawString(tolValArr[i], x + boxW / 2, y + boxH / 2, 8);

  }

  tft.setTextDatum(TL_DATUM);
}

int recordMax = 20;
float powerReadingsChart[20];
int readingCount = 0;
int graphMaxVal = 0;

//First: Bus Volt, Drop (Shunt) Volt, Current, Power
//Second: Now, Avg, Min, Max

float readings[4][4];
int powerReadingsX;
int powerReadingsY;
int powerReadingsW;
int powerReadingsH;
int powerChartX;
int powerChartY;
int powerChartW;
int powerChartH;

void drawChart() {
  int x = powerChartX;
  int y = powerChartY;
  int margin = 5;

  int trueGraphMax = 0;


  for (int i = 0; i < readingCount; i++) {
    trueGraphMax = max(graphMaxVal, (int)powerReadingsChart[i]);
  }

  //if origMaxVal != graphMaxVal

  graphMaxVal = 10 * round(trueGraphMax / 10.0);


  if (trueGraphMax > graphMaxVal) {
    graphMaxVal += 10;
  }

  if (graphMaxVal<10){
    graphMaxVal = 10;
  }


  tft.loadFont(STFONT18);
  tft.setTextColor(st_WHITE, st_BLACK);
  tft.setTextDatum(MR_DATUM);
  int padding = tft.textWidth("99"); // get the width of the text in pixels
  tft.setTextPadding(padding);


  tft.setTextDatum(MR_DATUM);
  x += 7;

  int lineMaxY = y + margin;
  int lineMidY = y + powerChartH / 2;
  int lineMinY = y + powerChartH - margin;

  //black out old graph
  tft.fillRect(x + margin, lineMaxY - 5, powerChartW - margin - 3, powerChartH + 5, st_BLACK);

  //redra graph
  tft.drawNumber(graphMaxVal, x, lineMaxY, st_WHITE);
  tft.drawFastHLine(x + margin, lineMaxY, powerChartW - margin * 2, st_GRAPHITE);

  tft.drawNumber(graphMaxVal / 2, x, lineMidY, st_WHITE);
  tft.drawFastHLine(x + margin, lineMidY, powerChartW - margin * 2, st_GRAPHITE);

  tft.drawNumber(0, x, lineMinY, st_WHITE);
  tft.drawFastHLine(x + margin, lineMinY, powerChartW - margin * 2, st_GRAPHITE);

  int xInterval = powerChartW / recordMax;
  int yInterval = powerChartH / recordMax;
  int graphCount = min (readingCount, recordMax);

  int pointx0;
  int pointy0;

  for (int i = 0; i < graphCount; i++) {

    y = map((int)powerReadingsChart[i], 0, graphMaxVal, lineMinY, lineMaxY);

    x += xInterval;
    tft.fillCircle(x, y, 2, st_WHITE);

    if (i > 0) {
      tft.drawLine(pointx0, pointy0, x, y, st_WHITE);
    }

    pointx0 = x;
    pointy0 = y;

    //y+=yInterval;

  }

}


float CURRENT_CALIBRATION  = 0.21;
float VOLTAGE_CALIBRATION = 0.011;


void getReadings() {

  // 1st
  //0 = Now
  //1 = Avg
  //2 = Min
  //3 = Max

  //2nd
  //0 - Bus
  //1 - Shunt
  //2 = Current
  //3 = Power


  float shuntvoltage = ina219.getShuntVoltage_mV() + VOLTAGE_CALIBRATION;
  float busvoltage = ina219.getBusVoltage_V() + VOLTAGE_CALIBRATION;
  float current_mA = ina219.getCurrent_mA() + CURRENT_CALIBRATION;
  float power_mW = ina219.getPower_mW();

  Serial.print("Bus Voltage:   "); Serial.print(busvoltage); Serial.println(" V");
  Serial.print("Shunt Voltage: "); Serial.print(shuntvoltage); Serial.println(" mV");
  Serial.print("Current:       "); Serial.print(current_mA); Serial.println(" mA");
  Serial.print("Power:         "); Serial.print(power_mW); Serial.println(" mW");

  if (busvoltage < 0.0) {
    busvoltage = 0.0;
  }
  if (shuntvoltage < 0.0) {
    shuntvoltage = 0.0;
  }
  if (current_mA < 0.0) {
    current_mA = 0.0;
  }
  if (power_mW < 0.0) {
    power_mW = 0.0;
  }

  readings[0][0] = busvoltage; //Bus Volt
  readings[0][1] = shuntvoltage; //shuntvoltage; //Shunt Volt
  readings[0][2] = current_mA; //current_mA;  //Current
  readings[0][3] = power_mW; //power_mW; //Power

  if (readingCount > recordMax - 1) {

    for (int i = 0; i < recordMax - 1; i++) {
      powerReadingsChart[i] = powerReadingsChart[i + 1];
    }
    powerReadingsChart[recordMax - 1] = readings[0][3];

  } else {
    powerReadingsChart[readingCount] = readings[0][3];
  }

  if (readingCount == 0) {
    for (int j = 0; j < 4; j++) {
      readings[1][j] = readings[0][j]; //Min
      readings[2][j] = readings[0][j]; //Min
      readings[3][j] = readings[0][j]; //Max
    }
  }


  readingCount++;
  for (int j = 0; j < 4; j++) {

    readings[1][j] = ((readings[1][j] * readingCount) + readings[0][j]) / (readingCount + 1);
    readings[2][j] = min(readings[0][j], readings[2][j]);
    readings[3][j] = max(readings[0][j], readings[3][j]);

  }

  drawChart();
}

void initReadings() {

  readingCount = 0;

  for (int j = 0; j < 4; j++) {

    for (int i = 0; i < 4; i++) {
      readings[j][i] = 0;
    }
  }

}

void displayReadings() {
  stopAnimation();
  //tickerPowerReadingsDisplay.detach();
  getReadings();

  int x = powerReadingsX;
  int origX = powerReadingsX;
  int y = powerReadingsY;
  int boxW = powerReadingsW;
  int boxH = powerReadingsH;
  int newFontSize = 24;
  int xTab = 2;
  int yTab = 6;
  char *rows[] = {"NOW", "AVG", "MIN", "MAX"};
  uint16_t headerColors[] = {st_BLUE, st_LTPURPLE, st_RED, st_HTPINK};

  for (int j = 0; j < 4; j++) {

    tft.loadFont(STFONT28);
    tft.setTextColor(st_ORANGE, st_BLACK);
    tft.setTextDatum(TR_DATUM);
    tft.drawString(rows[j], x - xTab, y + boxH, st_BLACK);

    for (int i = 0; i < 4; i++) {
      x += boxW;
      int padding = tft.textWidth("99.99"); // get the width of the text in pixels
      tft.setTextPadding(padding);
      tft.setTextColor(headerColors[i], st_BLACK);
      tft.setTextDatum(TR_DATUM);
      //tft.drawFloat(testF, 2, x, y + boxH, 8);
      tft.drawFloat(readings[j][i], 2, x, y + boxH, 8);
      x += xTab;
    }

    x = origX;
    y += newFontSize + yTab;
  }

  tft.setTextDatum(TL_DATUM);
  //tickerPowerReadingsDisplay.attach(10, displayReadings);
  startAnimation();

}

void measurePower(uint16_t backgroundColor) {

  initReadings();
  int x = 10; //45;
  int y = 30; //30;
  int boxW = 60; //72;
  int boxH = 32;
  int rad = 10;
  int yTab = 6;
  int xTab = 2;
  int origX = x;

  int chartW = 285;
  int chartH = 120;

  powerChartX = x + 5 + rad;
  powerChartY =  y + 5 + rad;
  powerChartW = chartW - 10 - rad * 2;
  powerChartH = chartH - 10 - rad * 2;
  tft.fillRoundRect(x, y, chartW, chartH, rad * 2, st_PEACH);
  tft.fillRoundRect(x + 5, y + 5, chartW - 10, chartH - 10, rad * 2, st_BLACK);


  char *headers[] = {"BUS VLT V", "DP VLT mV", "CUR mA", "PWR W"};
  uint16_t headerColors[] = {st_BLUE, st_LTPURPLE, st_RED, st_HTPINK};

  x = 45;
  origX = x;
  y += chartH + 10;

  for (int i = 0; i < 4; i++) {

    tft.fillRect(x, y, boxW, boxH, headerColors[i]);
    tft.loadFont(STFONT18);
    tft.setTextColor(st_BLACK, headerColors[i]);
    tft.setTextDatum(TR_DATUM);
    tft.drawString(headers[i], x + boxW - xTab, y + boxH / 3, st_BLACK);

    x += boxW + xTab;

  }

  int newFontSize = 24; //18;

  powerReadingsX = origX;
  powerReadingsY = y + yTab;
  powerReadingsW = boxW;
  powerReadingsH = boxH;

  x = powerReadingsX;
  y = powerReadingsY;

  displayReadings();
  // tickerPowerReadingsDisplay.attach(10, displayReadings);
}


void displayLEDCalc(uint16_t backgroundColor) {

  vs = 3.3;
  vf = 2.0;
  cf = 20;
  calcResistance();

  int x = 5;
  int y = 70;
  int boxW = 40;
  int boxH = 40;
  int rad = 5;
  int yTab = 50;
  int xTab = 105;

  tft.loadFont(STFONT28);
  tft.setTextColor(st_WHITE, st_BLACK);
  tft.setTextDatum(TL_DATUM);
  tft.drawString("S VOLTAGE:", x, y, st_WHITE);
  vsX = x + xTab;
  vsY = y - boxH / 4;
  handleDigitBoxF(vsX, vsY, boxW, boxH, rad, backgroundColor, vs);
  drawToggleButtons(vsX + boxW, vsY, st_BLUE, st_DKGRAY, &vsInc, &vsDec);


  y += yTab;
  tft.loadFont(STFONT28);
  tft.setTextColor(st_WHITE, st_BLACK);
  tft.setTextDatum(TL_DATUM);
  tft.drawString("F VOLTAGE:", x, y, st_WHITE);
  vfX = x + xTab;
  vfY = y - boxH / 4;
  handleDigitBoxF(vfX, vfY, boxW, boxH, rad, backgroundColor, vf);
  drawToggleButtons(vfX + boxW, vfY, st_BLUE, st_DKGRAY, &vfInc, &vfDec);

  y += yTab;
  tft.loadFont(STFONT28);
  tft.setTextColor(st_WHITE, st_BLACK);
  tft.setTextDatum(TL_DATUM);
  tft.drawString("F CURR (mA):", x, y, st_WHITE);
  cfX = x + xTab;
  cfY = y - boxH / 4;
  handleDigitBoxI(cfX, cfY, boxW, boxH, rad, backgroundColor, cf);
  drawToggleButtons(cfX + boxW, cfY, st_BLUE, st_DKGRAY, &cfInc, &cfDec);


  y += yTab;
  tft.loadFont(STFONT28);
  tft.setTextColor(st_WHITE, st_BLACK);
  tft.setTextDatum(TL_DATUM);
  tft.drawString("OHMS:", x, y, st_WHITE);
  rX = x + xTab;
  rY = y - boxH / 4;
  float rf = 500;
  handleDigitBoxResistance(rX, rY, boxW, boxH, rad, backgroundColor);

  y += yTab;


}

void handleDigitBoxF(int x, int y, int boxW, int boxH, int rad, uint16_t backgroundColor, float f) {
  tft.fillRoundRect(x, y, boxW, boxH, rad, st_BLACK);
  tft.drawRoundRect(x, y, boxW, boxH, rad, backgroundColor);
  tft.loadFont(STFONT28);
  tft.setTextColor(st_WHITE, st_BLACK);

  int padding = tft.textWidth("9.9"); // get the width of the text in pixels
  tft.setTextPadding(padding);
  tft.setTextDatum(TR_DATUM);
  tft.drawFloat(f, 1, x + boxW - 5, y + boxH / 4, 8);



}

void handleDigitBoxI(int x, int y, int boxW, int boxH, int rad, uint16_t backgroundColor, int i) {
  tft.fillRoundRect(x, y, boxW, boxH, rad, st_BLACK);
  tft.drawRoundRect(x, y, boxW, boxH, rad, backgroundColor);
  tft.loadFont(STFONT28);
  tft.setTextColor(st_WHITE, st_BLACK);

  int padding = tft.textWidth("99"); // get the width of the text in pixels
  tft.setTextPadding(padding);
  tft.setTextDatum(TR_DATUM);
  tft.drawNumber(i, x + boxW - 5, y + boxH / 4, 8);
}

void handleDigitBoxResistance(int x, int y, int boxW, int boxH, int rad, uint16_t backgroundColor) {
  tft.fillRoundRect(x, y, boxW, boxH, rad, st_BLACK);
  // tft.drawRoundRect(x, y, boxW, boxH, rad, backgroundColor);
  tft.loadFont(STFONT28);
  tft.setTextColor(st_ORANGE, st_BLACK);
  tft.drawRightString(resistance, x + boxW - 5, y + boxH / 4, 8);
}

void calcResistance() {

  float res = (vs - vf) / cf * 1000;
  if (res < 0) {
    strcpy(resistance, "N/A");
  } else {
    itoa(res, resistance, 10);
  }
}

void drawToggleButtons(int x, int y, uint16_t leftColor, uint16_t rightColor, tsButton *leftB, tsButton *rightB) {

  tft.loadFont(STFONT18);

  int buttonSpaceOver = 15;
  int buttonW = 46;
  int buttonH = 36;
  int buttonR = buttonH / 2;
  int gap = 2;
  int textMargin = 5;

  //draw left button
  int lButtonRoundStartX = x  + buttonSpaceOver;
  int lButtonRectStartX = lButtonRoundStartX + buttonR;
  tft.fillRoundRect(lButtonRoundStartX, y, buttonW, buttonH, buttonR, leftColor);
  tft.fillRect(lButtonRectStartX, y, buttonW, buttonH, leftColor);
  cfUP[0] = lButtonRoundStartX;
  cfUP[1] = lButtonRoundStartX + buttonW;
  cfUP[2] = y;
  cfUP[3] = y + buttonH;


  //draw right button
  int rButtonRectStartX = lButtonRectStartX + buttonW + gap;
  int rButtonRoundStartX = rButtonRectStartX + buttonR;

  tft.fillRoundRect(rButtonRoundStartX, y, buttonW, buttonH, buttonR, rightColor);
  tft.fillRect(rButtonRectStartX, y, buttonW, buttonH, rightColor);

  //add left Text
  tft.setTextColor(st_BLACK, leftColor);
  tft.setTextDatum(TR_DATUM);
  tft.drawString("INC", rButtonRectStartX - gap - textMargin, y + textMargin * 3.5, 8);

  // tft.drawRightString("INC", rButtonRectStartX - gap - textMargin, y + textMargin * 3.5, 8);


  //add right Text
  tft.setTextColor(st_BLACK, rightColor);
  tft.setTextDatum(TL_DATUM);
  tft.drawString("DEC", rButtonRectStartX + textMargin, y + textMargin * 3.5, 8);

  leftB->x  = lButtonRoundStartX;
  leftB->y  = y;
  leftB->w  = buttonW;
  leftB->h  = buttonH;

  rightB->x  = rButtonRectStartX;
  rightB->y  = y;
  rightB->w  = buttonW;
  rightB->h  = buttonH;
}
