
int newsItem = 0;

void loadNewsJSON() {
  allButtonsOff();

  File newsJSON = SPIFFS.open("/news.json", FILE_READ);

  if (!newsJSON) {
    Serial.println("The file does not exist");
    return;
  } else {
    size_t capacity = newsJSON.size() * 2;
    if ( capacity == 0 ) {
      Serial.println("The file is empty");
    } else {
      Serial.println("Getting data");

      const size_t capacity = JSON_ARRAY_SIZE(10) + 11 * JSON_OBJECT_SIZE(2) + 3500;
      DynamicJsonDocument doc(capacity);

      DeserializationError err = deserializeJson(doc, newsJSON);

      if (err) {
        Serial.print(F("deserializeJson() failed: "));
        Serial.println(err.c_str());
        return;
      }

      serializeJson(doc, Serial);

      //const size_t capacity = JSON_ARRAY_SIZE(10) + 11 * JSON_OBJECT_SIZE(2) + 3500;
      //DynamicJsonDocument doc(capacity);

      //deserializeJson(doc, json);
      int count = doc["count"]; // 10

      if (newsItem >= count) {
        newsItem = 0;
      }

      JsonArray articles = doc["articles"];


      char *newsArr[] = {"NEWS HEADLINES"};
      lcarsBackground(st_LTPURPLE, newsArr, 0 , 0);

      int x;
      int y = 40;
      int yTab = 60;
      uint16_t rowColor;

      tft.setTextDatum(TL_DATUM);
      int newsEntryCount = 0;



      newsEntryCount++;

      const char* title = articles[newsItem]["t"];
      const char* desc = articles[newsItem]["d"];

      String lineS;
      int lineLength;
      int prevWordBreak;
      int currWordBreak;
      int charCounter;

      for (int k = 0; k < 2; k++) {

        if (k == 0) {
          lineS = title;
          lineLength = 38;
          tft.setTextColor(st_WHITE, st_BLACK);
          tft.loadFont(STFONT28);
          x = 10;
        } else {
          lineS = desc;
          lineLength = 38;
          tft.setTextColor(st_LTGRAY, st_BLACK);
          tft.loadFont(STFONT24);
          x = 20;
        }

        int lineSLength = lineS.length();
        prevWordBreak = 0;
        currWordBreak = 0;
        charCounter = 0;

        for (int j = 0; j < lineSLength; j++) {
          charCounter++;

          if (charCounter < lineLength) {

            if (lineS.charAt(j) == ' ') {
              currWordBreak = j;
            }

          } else {

            tft.setCursor(x, y);
            tft.print(lineS.substring(prevWordBreak, currWordBreak)); //print through the saved word break
            y += 30; //increment row
            prevWordBreak = currWordBreak + 1; //set new word break
            charCounter = 0;

          }

        }
        tft.setCursor(x, y);
        //tft.print("test");
        tft.print(lineS.substring(prevWordBreak, lineSLength)); //need to do a final print

        y += yTab;

      }
      newsItem++;

    }
  }
}
