void displayBATT() {

  float measuredvbat = analogRead(VBATPIN);
  
  measuredvbat *= 2;    // we divided by 2, so multiply back
  measuredvbat *= 3.3;  // Multiply by 3.3V, our reference voltage
  measuredvbat /= 4095; // convert to voltage

  float battperc = (measuredvbat / 3.7)*100;

  if (battperc > 100) {
    battperc = 100;
  }

  //Serial.print("VBat Perc: " ); Serial.println(battperc);
  //Serial.print("VBat Perc INT: " ); Serial.println((int)battperc);

  char battC[4];
  itoa(battperc, battC, 10);

  char newBatt[5];

  strcpy(newBatt, battC);
  strcat(newBatt, "%");

  updateMenuData(battX, battY, battVal, newBatt, st_ORANGE, st_BLACK, STFONT38);
  strcpy(battVal, newBatt);

}

/*void getBatteryVoltage(){

  adc1_config_width(ADC_WIDTH_12Bit); // 0 .. 4095
  adc1_config_channel_atten(ADC1_CHANNEL_1,ADC_ATTEN_11db);

  Serial.print("VBat Raw: " ); Serial.println(adc1_get_raw(ADC1_CHANNEL_7));
   
  double measuredvbat =adc1_get_raw(ADC1_CHANNEL_7); // Note: you can also try analogRead(13);
  measuredvbat *= 2;    // we divided by 2, so multiply back
  measuredvbat *= 3.3;  // Multiply by 3.3V, our reference voltage
  measuredvbat *= 1.1;  // Multiply by 1.1V, the ADC reference voltage
  measuredvbat /= 4095; //1024; // convert to voltage
  Serial.print("VBat: " ); Serial.println(measuredvbat);
}*/


void displayWIFI() {

  char newWifi[5];

  if (WiFi.status() == WL_CONNECTED) {
    strcpy(newWifi, "CONN");
    tickerWifiStatus.detach();
    //tickerWifiStatus.attach(90, displayWIFI); //getWeather every 90 secs;
  } else {
    tickerWifiStatus.detach();
    tickerWifiStatus.attach(3, displayWIFI); //getWeather every 90 secs;

    if (WiFi.status() == WL_NO_SHIELD) {
      strcpy(newWifi, "ERR");
    }

    if (WiFi.status() == WL_IDLE_STATUS) {
      strcpy(newWifi, "IDLE");
    }

    if (WiFi.status() == WL_SCAN_COMPLETED) {
      strcpy(newWifi, "SCAN");
    }

    if (WiFi.status() == WL_NO_SSID_AVAIL) {
      strcpy(newWifi, "NONE");
    }

    if (WiFi.status() == WL_CONNECT_FAILED) {
      strcpy(newWifi, "FAIL");
    }

    if (WiFi.status() == WL_CONNECTION_LOST) {
      strcpy(newWifi, "LOST");
    }

    if (WiFi.status() == WL_DISCONNECTED) {
      strcpy(newWifi, "OFF");
    }
  }

  updateMenuData(wifiX, wifiY, wifiVal, newWifi, st_PURPLE, st_BLACK, STFONT38);
  strcpy(wifiVal, newWifi);
}

void connectWifi() {
  // Start WiFi
  tickerWifiStatus.detach();
  tickerWifiStatus.attach(1, displayWIFI); //getWeather every 10 mins;
  Serial.println("Connecting to ");
  Serial.print(WIFI_SSID);
  WiFi.begin(WIFI_SSID, WIFI_PASSWORD);

  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("\nConnected to Wifi.");

  // Configure MQTT Client
  httpsClient.setCACert(AWS_CERT_CA);
  httpsClient.setCertificate(AWS_CERT_CRT);
  httpsClient.setPrivateKey(AWS_CERT_PRIVATE);
  mqttClient.setServer(AWS_IOT_ENDPOINT, PORT);
  mqttClient.setCallback(mqttCallback);

  connectAWSIoT();
  //WiFi.setTxPower(WIFI_POWER_7dBm); This doesnt work
}

void connectAWSIoT() {
  while (!mqttClient.connected()) {
    if (mqttClient.connect(uniqId)) {
      Serial.println("Connected to IoT.");
      int qos = 0;

      for (int i = 0; i < numOfTopics; i++) {
        char topic[60];
        strcpy(topic, uniqId);
        strcat(topic, "/");
        strcat(topic, topics[i]);
        mqttClient.subscribe(topic, qos);
      }


    } else {
      Serial.print("Failed. Error state=");
      Serial.print(mqttClient.state());
      // Wait 5 seconds before retrying
      delay(5000);
    }
  }
}
