void requestTimeInfoOLD() {

  Serial.println("Requesting Time Sync");

  const size_t capacity = JSON_OBJECT_SIZE(2) + 40;
  DynamicJsonDocument doc(capacity);

  doc["lat"] = LAT;
  doc["lng"] = LNG;

  char buffer[512];
  size_t n = serializeJson(doc, buffer);
  sendRequest("timeInfo", buffer);

}

void requestTimeInfo() {

  Serial.println("Requesting Time Sync");

  const size_t capacity = JSON_OBJECT_SIZE(1) + 100;
  DynamicJsonDocument doc(capacity);

  doc["timeZone"] = TIMEZONE;


  serializeJson(doc, Serial);

  char buffer[512];
  size_t n = serializeJson(doc, buffer);
  sendRequest("timeInfo", buffer);

}

void requestHourlyWeather() {

  Serial.println("Requesting Hourly Weather");

  const size_t capacity = JSON_OBJECT_SIZE(2) + 40;
  DynamicJsonDocument doc(capacity);

  doc["lat"] = LAT;
  doc["lng"] = LNG;

  char buffer[512];
  size_t n = serializeJson(doc, buffer);
  sendRequest("hourlyWeatherInfo", buffer);

}

void requestDailyWeather() {

  Serial.println("Requesting Daily Weather");

  const size_t capacity = JSON_OBJECT_SIZE(2) + 40;
  DynamicJsonDocument doc(capacity);

  doc["lat"] = LAT;
  doc["lng"] = LNG;

  char buffer[512];
  size_t n = serializeJson(doc, buffer);
  sendRequest("dailyWeatherInfo", buffer);
}

void requestDeviceCode(char *auth) {

  Serial.println("Requesting Device Code");

  const size_t capacity = JSON_OBJECT_SIZE(1) + 40;
  DynamicJsonDocument doc(capacity);

  doc["auth"] = auth;

  char buffer[512];
  size_t n = serializeJson(doc, buffer);
  sendRequest("requestDeviceCode", buffer);
}

void requestSchedule() {

  Serial.println("Requesting Schedule");

  const size_t capacity = JSON_OBJECT_SIZE(1) + 100;
  DynamicJsonDocument doc(capacity);

  doc["timeZone"] = TIMEZONE;

  char buffer[512];
  size_t n = serializeJson(doc, buffer);
  sendRequest("requestSchedule", buffer);

}

void requestNews(char *source) {

  Serial.println("Requesting News");

  const size_t capacity = JSON_OBJECT_SIZE(1) + 100;
  DynamicJsonDocument doc(capacity);

  doc["source"] = source;

  char buffer[512];
  size_t n = serializeJson(doc, buffer);
  sendRequest("requestNews", buffer);
}

void requestFitness() {

  Serial.println("Requesting Fitness");

  const size_t capacity = JSON_OBJECT_SIZE(1) + 100;
  DynamicJsonDocument doc(capacity);

  doc["timeZone"] = TIMEZONE;

  char buffer[512];
  size_t n = serializeJson(doc, buffer);
  sendRequest("requestFitness", buffer);

}
