int timeRefreshSec = 1;
boolean checkAtMin = false;
boolean timeTickerSet = false;
void displayTime() {

  struct tm timeinfo;
  if (!getLocalTime(&timeinfo)) {
    Serial.println("Failed to obtain time");
    if (!syncReady) {
      requestTimeInfo();
    }
    tickerDisplayTime.attach(30, displayTime); //try again in 30 sec
    return;
  }

  if (!timeTickerSet) {
    tickerDisplayTime.attach(timeRefreshSec, displayTime);
    timeTickerSet = true;
  }

  char newTimeHour[6];
  char timeHour[3];
  char timeMin[3];
  char timeSec[3];
  strftime(timeHour, 3, "%H", &timeinfo); //use I for 12 hr time
  strftime(timeMin, 3, "%M", &timeinfo);
  strftime(timeSec, 3, "%S", &timeinfo);
  strcpy(newTimeHour, timeHour);
  strcat(newTimeHour, ":");
  strcat(newTimeHour, timeMin);

  char compareAlarm[9];//YYYYMMDDHHmm
  strftime(compareAlarm, 9, "%m%d%H%M", &timeinfo);



  if ((strcmp(timeSec, "00") == 0) && !checkAtMin) {
    checkAtMin = true;
    timeRefreshSec = 60;
    tickerDisplayTime.detach();
    tickerDisplayTime.attach(timeRefreshSec, displayTime);
    strcpy(alarmDateTime, compareAlarm);
  }

  /*if (checkAtMin && ((strcmp(timeMin, "00") == 0) || (strcmp(timeMin, "15") == 0) || (strcmp(timeMin, "30") == 0) || (strcmp(timeMin, "45") == 0))) {
    //requestHourlyWeather();
    displayBATT();
    displayWIFI();
    if (strcmp(timeMin, "00") == 0){//on the hour, get daily
      //requestDailyWeather();
      requestNews(NEWS_SOURCE);
    }
    if (isAuth(0)) {
      requestSchedule();
    }
    }*/

  if (strcmp(timeVal, newTimeHour) != 0) {


    if ((strcmp(newTimeHour, "02:00") == 0)) { //we check at 2AM to ensure that we get any DST changes
      requestTimeInfo();
    }

    if (strcmp(compareAlarm, alarmDateTime) == 0) { //we check at 2AM to ensure that we get any DST changes
      //loadScheduleJSON(false);
      checkAlarm = true;
    }

    Serial.println(&timeinfo, "%A, %B %d %Y %H:%M:%S");


    updateMenuData(timeX, timeY, timeVal, newTimeHour, st_WHITE, st_BLACK, STFONT38);
    strcpy(timeVal, newTimeHour);

    char newDay[4];

    int dayInt = timeinfo.tm_wday;
    switch (dayInt) {
      case 0:
        strcpy(newDay, "SUN");
        break;
      case 1:
        strcpy(newDay, "MON");
        break;
      case 2:
        strcpy(newDay, "TUE");
        break;
      case 3:
        strcpy(newDay, "WED");
        break;
      case 4:
        strcpy(newDay, "THU");
        break;
      case 5:
        strcpy(newDay, "FRI");
        break;
      case 6:
        strcpy(newDay, "SAT");
        break;
      default:
        strcpy(newDay, "   ");
        break;
    }

    if (strcmp(dayVal, newDay) != 0) {

      updateMenuData(dayX, dayY, dayVal, newDay, st_TAN, st_BLACK, STFONT38);
      strcpy(dayVal, newDay);

      char newDate[3];
      strftime(newDate, 3, "%d", &timeinfo);

      updateMenuData(dateX, dateY, dateVal, newDate, st_TAN, st_BLACK, STFONT38);
      strcpy(dateVal, newDate);
    }
  }
}
