

void allButtonsOff() {
  ledCalcScreen = false;
  measurePwrScreen = false;
  resCodeScreen = false;
  powerReadingsDisplay = false;
  menuDisplay = false;
}


/*struct tsButton {
  const char[10] screen;
  bool pressed;
  bool lastTSstate;
  bool justPressedTS;
  bool justReleasedTS;
  int x,
  int y,
  int buttonW,
  int buttonH
  };*/

boolean doesContain(int16_t x, int16_t y, tsButton *button) {

  int bX;
  int bY;
  int bW;
  int bH;

  bX = button->x;
  bY = button->y;
  bW = button->w;
  bH = button->h;

  return ((x >= bX) && (x < (bX + bW)) && (y >= bY) &&
          (y < (bY + bH))
         );
}

void pressTS(boolean p, tsButton *button) {

  button-> laststate = button-> currstate;
  button-> currstate = p;
}

boolean isPressedTS(tsButton *button) {

  boolean cs = button-> currstate;
  return (cs);
}

boolean justPressedTS(tsButton *button) {

  boolean cs = button-> currstate;
  boolean ls = button-> laststate;
  return (cs && !ls);
}

boolean justReleasedTS (tsButton *button) {

  boolean cs = button-> currstate;
  boolean ls = button-> laststate;
  return (!cs && ls);
}


void handlePress(int px, int py) {

  int debounceMS = 50; //100
  int y;
  int x;
  y = map(px, TS_MAXX, TS_MINX, tft.height(), 0);
  x = map(py, TS_MINY, TS_MAXY, 0, tft.width());

  //Serial.print("oY:");
  //Serial.println(px);
  //Serial.print("mY:");
  //Serial.println(y);

  //Serial.print("Button x:");
  //Serial.println(doesContain(x, y, testB));

  if (doesContain(x, y, &tsWeather)) {
    pressTS(true, &tsWeather);
  } else {
    pressTS(false, &tsWeather);
  }

  if (justPressedTS(&tsWeather)) {
    //Serial.println("just Pressed!");
    envInt = 0;
    displayEnviro();
    delay(debounceMS); // UI debouncing
  }

  //LED Calc----------------------------------------
  if (ledCalcScreen) {

    int boxW = 40;
    int boxH = 40;
    int rad = 5;

    //Supply Voltage Inc----------------------------------------
    if (doesContain(x, y, &vsInc)) {
      pressTS(true, &vsInc);
    } else {
      pressTS(false, &vsInc);
    }

    if (justReleasedTS(&vsInc)) { }

    if (justPressedTS(&vsInc)) {
      //Serial.println("just Pressed!");
      vs += 0.1;
      handleDigitBoxF(vsX, vsY, boxW, boxH, rad, st_ORANGE, vs);
      calcResistance();
      handleDigitBoxResistance(rX, rY, boxW, boxH, rad, st_ORANGE);
      delay(debounceMS); // UI debouncing
    }

    //Supply Voltage Dec----------------------
    if (doesContain(x, y, &vsDec)) {
      pressTS(true, &vsDec);
    } else {
      pressTS(false, &vsDec);
    }

    if (justReleasedTS(&vsDec)) { }

    if (justPressedTS(&vsDec)) {
      //Serial.println("just Pressed!");
      vs -= 0.1;
      handleDigitBoxF(vsX, vsY, boxW, boxH, rad, st_ORANGE, vs);
      calcResistance();
      handleDigitBoxResistance(rX, rY, boxW, boxH, rad, st_ORANGE);
      delay(debounceMS); // UI debouncing
    }

    //Forward Voltage Inc----------------------
    if (doesContain(x, y, &vfInc)) {
      pressTS(true, &vfInc);
    } else {
      pressTS(false, &vfInc);
    }

    if (justReleasedTS(&vfInc)) {
    }

    if (justPressedTS(&vfInc)) {
      //Serial.println("just Pressed!");
      vf += 0.1;
      handleDigitBoxF(vfX, vfY, boxW, boxH, rad, st_ORANGE, vf);
      calcResistance();
      handleDigitBoxResistance(rX, rY, boxW, boxH, rad, st_ORANGE);
      delay(debounceMS); // UI debouncing
    }

    //Forward Voltage Dec----------------------
    if (doesContain(x, y, &vfDec)) {
      pressTS(true, &vfDec);
    } else {
      pressTS(false, &vfDec);
    }

    if (justReleasedTS(&vfDec)) {
    }

    if (justPressedTS(&vfDec)) {
      //Serial.println("just Pressed!");
      vf -= 0.1;
      handleDigitBoxF(vfX, vfY, boxW, boxH, rad, st_ORANGE, vf);
      calcResistance();
      handleDigitBoxResistance(rX, rY, boxW, boxH, rad, st_ORANGE);
      delay(debounceMS); // UI debouncing
    }

    //Forward Current Inc----------------------
    if (doesContain(x, y, &cfInc)) {
      pressTS(true, &cfInc);
    } else {
      pressTS(false, &cfInc);
    }

    if (justReleasedTS(&cfInc)) {
    }

    if (justPressedTS(&cfInc)) {
      //Serial.println("just Pressed!");
      cf += 1;
      handleDigitBoxI(cfX, cfY, boxW, boxH, rad, st_ORANGE, cf);
      calcResistance();
      handleDigitBoxResistance(rX, rY, boxW, boxH, rad, st_ORANGE);
      delay(debounceMS); // UI debouncing
    }

    //Forward Voltage Dec----------------------
    if (doesContain(x, y, &cfDec)) {
      pressTS(true, &cfDec);
    } else {
      pressTS(false, &cfDec);
    }

    if (justReleasedTS(&cfDec)) {
    }

    if (justPressedTS(&cfDec)) {
      //Serial.println("just Pressed!");
      cf -= 1;
      handleDigitBoxI(cfX, cfY, boxW, boxH, rad, st_ORANGE, cf);
      calcResistance();
      handleDigitBoxResistance(rX, rY, boxW, boxH, rad, st_ORANGE);
      delay(debounceMS); // UI debouncing
    }


  }
}
